/************************************************************************
 *
 * Copyright (c) 2005
 * Infineon Technologies AG
 * St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 *
 ************************************************************************/

#ifndef __CONFIG_H
#define __CONFIG_H

#define CONFIG_MIPS32       1   /* MIPS 4Kc CPU core    */
#define CONFIG_INCA_IP2     1   /* on a INCA-IP2 Board  */

#undef  CONFIG_DISPLAY

#ifndef CPU_CLOCK_RATE
#define CPU_CLOCK_RATE  400000000   
#endif

#undef  EMULATION
#undef  EMULATION_PRO
#undef  VENUS

#if TEXT_BASE == 0xb0000000
#define INCAIP2_BOOT_FROM_EBU
/* Enable INCAIP2_DDR_11_COL for DDR chips with 11 columns like on Inca-IP2 Eval board. 
   Otherwise 10 columns will be used */
#define INCAIP2_DDR_11_COL
#else
#undef  INCAIP2_BOOT_FROM_EBU     
#endif

#define INCAIP2_USE_DDR_RAM
#define CFG_DDR_SIZE         64         /* 128 for eval, 64 for demoboard */

#define INFINEON_EBU_BOOTCFG    0x40C4  /* CMULT = 8 */
#define IFX_EBU_ADDR_REGION0 0x10000000 /* Default CS0 used by EBU for external boot after reset. */
#define IFX_EBU_ADDR_REGION3 0x19000000 /* CS1 */
#define IFX_EBU_ADDR_REGION2 0x1B000000 /* PC card */
#define IFX_EBU_ADDR_REGION1 0x1C000000

#define CONFIG_BOOTDELAY    5   /* autoboot after 5 seconds */

/* Define this to disable bluetooth chip on reference design */
#define CONFIG_INCA_IP2_BLUETOOTH_DISABLE

#define CONFIG_BAUDRATE     115200
#define STOP_WITH_ENTER	    1	/*not all keys are valid to stop autoboot but only "ENTER" */

/* valid baudrates */
#define CFG_BAUDRATE_TABLE  { 9600, 19200, 38400, 57600, 115200 }

#define CONFIG_TIMESTAMP        /* Print image info with timestamp */

#define CONFIG_PREBOOT  "echo;" \
    "echo Type \"run <BOOTMODE>\" to start Linux. ;" \
    "echo The following bootmodes are supported: ;" \
    "echo nor_nfs, nor_ramdisk, nand_nfs, nand_ramdisk, nand_jffs2, net_nfs and net_jffs2. ;" \
    "echo "

#undef  CONFIG_BOOTARGS

#define CONFIG_EXTRA_ENV_SETTINGS                   \
    "autoload=no\0"                     \
    "nfsargs=setenv bootargs root=/dev/nfs rw "         \
        "nfsroot=$(serverip):$(rootpath),rsize=1024,wsize=1024\0"         \
    "ramargs=setenv bootargs root=/dev/ram rw\0"            \
    "jffs2args=setenv bootargs root=/dev/mtdblock$(mtd_rootpart) rw rootfstype=jffs2\0" \
    "addip=setenv bootargs $(bootargs) "                \
        "ip=$(ipaddr):$(serverip):$(gatewayip):$(netmask)"  \
        ":$(hostname):$(netdev):off\0"              \
    "addmisc=setenv bootargs $(bootargs) "              \
        "console=ttyS0,$(baudrate) "                \
        "ethaddr=$(ethaddr) "                   \
        "panic=1\0"                     \
    "nor_nfs=run nfsargs addip addmisc;"              \
        "bootm $(nor_kernel_addr)\0"                \
    "nor_ramdisk=run ramargs addip addmisc loadimg;"             \
        "bootm $(nor_kernel_addr) $(nor_ramdisk_addr)\0"        \
    "net_nfs=tftp $(ram_kernel_addr) $(bootfile);"                \
        "run nfsargs addip addmisc;bootm\0"         \
    "net_jffs2=tftp $(ram_kernel_addr) $(bootfile);"      \
        "run jffs2args addip addmisc;bootm $(ram_kernel_addr)\0"   \
    "nand_nfs=run nfsargs addip addmisc;"              \
        "run nandloadkernel ; bootm $(ram_kernel_addr)\0"          \
    "nand_ramdisk=run ramargs addip addmisc;"              \
        "run nandloadkernel ; run nandloadramdisk ; " \
        " bootm $(ram_kernel_addr) $(ram_ramdisk_addr)\0"        \
    "nand_jffs2=run jffs2args addip addmisc;run nandloadkernel;" \
        "bootm $(ram_kernel_addr)\0"                    \
    /*"emu_linux=run ramargs addip addmisc; bootm 0x80800000 0xa0e00000\0"*/ \
    /*"verify=n\0"*/ \
    "ram_kernel_addr=0x80800000\0"                    \
    "ram_ramdisk_addr=0x82000000\0"                   \
    "nor_kernel_addr=0xb0000000\0"                    \
    "nor_ramdisk_addr=0xb0200000\0"                   \
    "nand_kernel_addr=0x00060000\0"                    \
    "nand_ramdisk_addr=0x00200000\0"                   \
    "nandloadkernel=nand read $(ram_kernel_addr) $(nand_kernel_addr) 0x001a0000\0" \
    "nandloadramdisk=nand read $(ram_ramdisk_addr) $(nand_ramdisk_addr) 0x00400000 \0" \
    "mtd_rootpart=5\0"                     \
    "rootpath=/opt/rootfs.incaip2\0"                 \
    "bootfile=uImage\0"                    \
  /*"ethaddr=00:01:02:03:04:05\0"                                  \
    "ipaddr=190.16.16.1\0"    \
    "serverip=190.16.7.246\0" \
    "nand_uboot=tftp 80500000 2nd_ll_ref.img;nand erase 0 4000; nand write 80500000 0 4000;tftp 80500000 ld_uboot_ref.img;nand erase 4000 40000; nand write.jffs2 80500000 4000 40000 \0" \
    "nand_kernel= tftp 80500000 uImage.pad; nand erase 60000 1a0000; nand write.jffs2 80500000 60000 $(filesize); tftp 80500000 rootfs.incaip2.nand.demo.img; nand erase 200000 400000; nand erase clean 200000 400000; nand write.jffs2 80500000 200000 $(filesize);reset\0" \
    "nand_setup=run nand_uboot;run nand_kernel\0"*/ \
    ""

#ifdef EMULATION
#define CONFIG_BOOTCOMMAND  "run emu_linux"
#define CONFIG_COMMANDS        (CONFIG_CMD_DFL  | \
                CFG_CMD_ASKENV  | \
                CFG_CMD_ELF     | \
                CFG_CMD_NAND    | \
                CFG_CMD_JFFS2   )
#else
#define CONFIG_BOOTCOMMAND  "run nand_jffs2"
#define CONFIG_COMMANDS        (CONFIG_CMD_DFL  | \
                CFG_CMD_ASKENV  | \
                CFG_CMD_DHCP    | \
                CFG_CMD_ELF     | \
                CFG_CMD_NAND    | \
                CFG_CMD_JFFS2   | \
                CFG_CMD_NFS     | \
                CFG_CMD_PING    | \
                CFG_CMD_SFLASH  | \
                CFG_CMD_SNTP    )
/*
 Example for boot from NAND:
 "ram_linux=nand read 0xa2000000 0 0x100000; run ramargs addip addmisc; bootm 0x80800000 0xa2000000\0"
*/ 

#endif /* EMULATION */

#include <cmd_confdefs.h>

/*
 * Miscellaneous configurable options
 */
#define CFG_LONGHELP                /* undef to save memory      */
#if TEXT_BASE == 0xb0000000
#define CFG_PROMPT      "INCA-IP2-ROM # "   /* Monitor Command Prompt    */
#else
#define CFG_PROMPT      "INCA-IP2-RAM # "   /* Monitor Command Prompt    */
#endif

#define CFG_CBSIZE      256     /* Console I/O Buffer Size   */
#define CFG_PBSIZE (CFG_CBSIZE+sizeof(CFG_PROMPT)+16)  /* Print Buffer Size */
#define CFG_MAXARGS     16      /* max number of command args*/

#define CFG_MALLOC_LEN      128*1024

#define CFG_BOOTPARAMS_LEN  128*1024

#ifdef EMULATION
#define CFG_HZ          (200000)
#else
#define CFG_HZ          (incaip2_get_cpuclk() / 2)
#endif

#define CFG_SDRAM_BASE      0x80000000

#define CFG_LOAD_ADDR       0x80100000  /* default load address */

#define CFG_MEMTEST_START   0x80100000
#define CFG_MEMTEST_END     0x80800000

#define CONFIG_NR_DRAM_BANKS    1


/*-----------------------------------------------------------------------
 * NOR FLASH
 */
#define  CONFIG_USE_NOR_FLASH
#define CFG_MAX_FLASH_BANKS	1	/* max number of memory banks */
#define CFG_MAX_FLASH_SECT	(2048)	/* max number of sectors on one chip */

/* The following #defines are needed to get flash environment right */
#define	CFG_MONITOR_BASE	TEXT_BASE
#define	CFG_MONITOR_LEN		(192 << 10)

#define CFG_INIT_SP_OFFSET	0x400000

#ifdef INCAIP2_BOOT_FROM_EBU
#define CFG_NOR_FLASH_BASE		(KSEG1 | IFX_EBU_ADDR_REGION0)
#else
#define CFG_NOR_FLASH_BASE		(KSEG1 | IFX_EBU_ADDR_REGION1)
/* If building a ddr_uboot.img for NOR based flash, set NOR region to 0
   and NAND region to 1 */
/* #define CFG_NOR_FLASH_BASE		(KSEG1 | IFX_EBU_ADDR_REGION0) */
#endif
#define CONFIG_FLASH_16BIT

/* timeout values are in ticks */
#define CFG_FLASH_ERASE_TOUT    (20*2 * CFG_HZ) /* Timeout for Flash Erase */
#define CFG_FLASH_WRITE_TOUT    (2 * CFG_HZ) /* Timeout for Flash Write */

#define CFG_JFFS2_FIRST_BANK  1
#define CFG_JFFS2_NUM_BANKS   1
#define CFG_JFFS_CUSTOM_PART

/*-----------------------------------------------------------------------
 * Ethernet/Switch configuration
 */
#define CONFIG_INCA_IP2_SWITCH
#define CONFIG_NET_MULTI

#define CFG_ETHERNET_MAC_ADDR   0xb9ff00f0
#define CFG_ETHERNET_MAC_SECT   0xb9ff0000
#define CFG_RX_ETH_BUFFER       20

/*-----------------------------------------------------------------------
 * Ethernet PHY configuration
 */
/* Evaluation System */
#define  CONFIG_PHY_MV88E1111
/* Reference System */
#undef  CONFIG_PHY_MV88E1121

/* On Reference System PHY and LAN-port are the other way around */
#ifdef CONFIG_PHY_MV88E1121
#define PHY_ROTATED	
#endif

#ifdef PHY_ROTATED	/* Reference System */
#define PHY_LAN 1
#define PHY_PC  0
#else			/* Evaluation System */
#define PHY_LAN 0
#define PHY_PC  1
#endif

/*-----------------------------------------------------------------------
 * Debug Ethernet configuration
 */
#undef  CONFIG_DRIVER_CS8900
#define CS8900_BUS16
#define CS8900_BASE IFX_EBU_ADDR_REGION2 + 0x300


/*-----------------------------------------------------------------------
 * Cache Configuration
 */
#define CONFIG_MIPS_FORCE_CACHE_WRITE_THROUGH
#define CFG_DCACHE_SIZE     16384
#define CFG_ICACHE_SIZE     16384
#define CFG_CACHE_LINE_SIZE 32
#define CFG_CACHE_LINE_NO   128
#define CFG_CACHE_NO_WAYS   4

/*-----------------------------------------------------------------------
 * NAND Configuration
 */
#include <asm/addrspace.h>

#define NEW_VERSION_NAND_SUPPORT 1   // for Large Page nand and some new features of nand.

#ifdef INCAIP2_BOOT_FROM_EBU
#define IFX_EBU_ADDR_REGION_BASE IFX_EBU_ADDR_REGION1 /* NAND flash in region1 (ebu_address_region  = 1) */
#else
#define IFX_EBU_ADDR_REGION_BASE IFX_EBU_ADDR_REGION0 /* NAND flash in region0 (ebu_address_region  = 0) */
/* If building a ddr_uboot.img for NOR based flash, set NOR region to 0
   and NAND region to 1 */
/* #define IFX_EBU_ADDR_REGION_BASE IFX_EBU_ADDR_REGION1 */
#endif

#define CFG_NAND_BASE       (KSEG1 | IFX_EBU_ADDR_REGION_BASE)  //start address
#define CONFIG_MTD_NAND_VERIFY_WRITE
#define CONFIG_MTD_NAND_UNSAFE
#define CONFIG_MTD_NAND_ECC
#define CONFIG_MTD_NAND_HW_ECC
#define CONFIG_MTD_NAND_ECC_JFFS2

#undef CONFIG_MTD_DEBUG
#define CONFIG_MTD_DEBUG_VERBOSE	2

#ifndef INCAIP2_BOOT_FROM_EBU
#define CONFIG_JFFS2_NAND   1                       /* jffs2 on nand support */
#endif
#define CONFIG_JFFS2_NAND_DEV   0                   /* nand device jffs2 lives on */
#define CONFIG_JFFS2_NAND_OFF   (6 * 1024 * 1024)   /* start of jffs2 partition */
#define CONFIG_JFFS2_NAND_SIZE  (2*1024*1024)       /* size of jffs2 partition */

#define CFG_MAX_NAND_DEVICE     1

#ifndef NEW_VERSION_NAND_SUPPORT
#undef  NAND_NO_RB
#undef  NAND_INVERT_RDBY
#define STMICRO_NAND		1	// ST NAND should skip issue ADDR after ReadID command.
#define SECTORSIZE		512
#define ADDR_COLUMN		1
#define ADDR_PAGE		3
#define ADDR_COLUMN_PAGE	4
#define NAND_ChipID_UNKNOWN 	0x00
#define NAND_MAX_FLOORS		1
#define NAND_MAX_CHIPS		1

#undef  NAND_DEBUG
#endif
/*-----------------------------------------------------------------------
 * USB Configuration
 */
//#define CONFIG_USB_OHCI 1
//#define CONFIG_USB_KEYBOARD 1
//#define CONFIG_USB_STORAGE 1
//#define CONFIG_DOS_PARTITION 1
//#define CFG_DEVICE_DEREGISTER 1 /* needed by CONFIG_USB_KEYBOARD */


/*-----------------------------------------------------------------------
 * Serial FLASH Configuration
 */
#define CONFIG_SERIAL_FLASH         1
#define CFG_MAX_SFLASH_SECT         128

#define CFG_SFLASH_LOGIC_ADDR       0xC0000000
#define CFG_SFLASH_LOGIC_ADDR_MASK  0xFF000000

/*-----------------------------------------------------------------------
 * Environment organization
 */
#undef  CFG_ENV_IS_NOWHERE
#ifndef CFG_ENV_IS_NOWHERE
#ifdef INCAIP2_BOOT_FROM_EBU
#define CFG_ENV_IS_IN_FLASH 1
#define CFG_ENV_SIZE		0x10000
#else
#define CFG_ENV_IS_IN_NAND 1
#define CFG_ENV_SIZE		0x4000
#endif
#else
#define CFG_ENV_SIZE		0x10000
#endif

#define CFG_ENV_NAND_OFFSET 0x50000

#define CFG_ENV_NOR_OFFSET      0x50000
#define CFG_ENV_NOR_ADDR		(CFG_NOR_FLASH_BASE + CFG_ENV_NOR_OFFSET)

#if defined(CFG_ENV_IS_IN_NAND)
    #define CFG_ENV_OFFSET  CFG_ENV_NAND_OFFSET
#elif defined(CFG_ENV_IS_IN_FLASH)
    #define CFG_ENV_OFFSET  CFG_ENV_NOR_OFFSET
    #define CFG_ENV_ADDR    CFG_ENV_NOR_ADDR
#endif

#endif  /* __CONFIG_H */
